#ifndef ASSERT
#define ASSERT
#include <assert.h>
#endif

#ifndef COMMONS
#include "commons.c"
#define COMMONS
#endif

/*
 * --------------------------------------------------------------
 * Contracts
 * --------------------------------------------------------------
 */

bool t_arrays_within(int a_length,
	int fromIndex,
	int toIndex) {
	return (0<=fromIndex && fromIndex<=toIndex && toIndex <=a_length);
}

bool t_arrays_sorted(int* a,
	int a_length,
	int fromIndex,
	int toIndex) {

	int i =fromIndex;
	for (; i<toIndex-1; i++) {
		if (a[i]>a[i+1])
			return FALSE;
	}
	return TRUE;
}

bool t_arrays_in(int* a,
	int a_length,
	int fromIndex,
	int toIndex,
	int key) {

	int i = fromIndex;
	for (; i<toIndex; i++) {
		if (a[i]==key)
			return TRUE;
	}
	return FALSE;
}

bool t_arrays_less(int* a,
	int fromIndex,
	int toIndex,
	int v)
{
	int i = fromIndex;
	for ( ; i<toIndex; i++) {
		if (a[i]>=v)
			return FALSE;
	}
	return TRUE;
}

bool t_arrays_grt(int* a,
        int fromIndex,
        int toIndex,
        int v)
{
        int i = fromIndex;
        for ( ; i<toIndex; i++) {
                if (a[i]<=v)
                        return FALSE;
        }
        return TRUE;
}



bool t_arrays_equals(int* a,
	int* b,
	int fromIndex,
	int toIndex)
{
	int i=fromIndex;
	for(;i<toIndex;i++) {
		if (a[i]!=b[i]) {
			return FALSE;
		}
	}
	return TRUE;
}


bool t_arrays_eq_value(int* a,
	int fromIndex,
	int toIndex,
	int val) {

	int i=fromIndex;
	for (;i<toIndex;i++) {
		if (a[i]!=val) {
			return FALSE;
		}
	}
	return TRUE;

}

bool t_arrays_object_eq(PObject* array,
	int fromIndex,
	int toIndex,
	PObject value)
{
	int i = fromIndex;
	for ( ; i <toIndex; i++) {
		if (array[i]!=value) {
			return FALSE;
		}
	}
	return TRUE;
}

bool t_arrays_object_nonnull(PObject* array,
	int fromIndex,
	int toIndex)
{
	int i = fromIndex;
	for ( ; i<toIndex; i++) {
		if (array[i]==NULL) {
			return FALSE;
		}
	}
	return TRUE;
}

bool t_arrays_object_eqnull(PObject* array,
	int fromIndex,
	int toIndex)
{
	int i = fromIndex;
	for ( ; i<toIndex; i++) {
		if (array[i]!=NULL)
			return FALSE;
	}
	return TRUE;
}

bool t_arrays_object_equals_2(PObject* a,
	PObject* b,
	int fromIndex,
	int toIndex)
{
	int i = fromIndex;
	for ( ; i<toIndex;i++) {
		if (a[i]!=b[i])
			return FALSE;
	}
	return TRUE;
}

bool t_arrays_object_sorted(PObject* a,
        int fromIndex,
        int toIndex) {

        int i =fromIndex;
        for (; i<toIndex-1; i++) {
		int leftValue = object_intValue(a[i]);
		int rightValue = object_intValue(a[i+1]);
                if (leftValue>rightValue)
                        return FALSE;
        }
        return TRUE;
}

bool t_arrays_in_bound(int a_length, int index) {
	return index>=0 && index<a_length;
}
